#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <allegro.h>
#include "0532cl.h"
#include "0532c.h"

// Array of nodes, but we will access to them using the pointers...
struct circnode *node[MAX_NODES];

struct circnode *actual_node;

int main(void)
{
    int end_loop = 0, key = 0;

    allegro_init();
    set_gfx_mode (GFX_SAFE, 320, 200, 0, 0);
    set_palette (desktop_palette);
    install_keyboard();

    init();

    draw_screen();

    while (end_loop == 0) {
	key = toupper(readkey() & 0xff);

	if (key == 'F') {
	    cycle_through_list(FORWARD);
	    draw_screen();
	}
	if (key == 'B') {
	    cycle_through_list(BACKWARD);
	    draw_screen();
	}
	if (key == 27)
	    end_loop++;
    }

    return 0;
}
END_OF_MAIN()

void draw_screen(void)
{
    struct circnode *temp;
    char arrow[8];
    int y = 0;

    clear (screen);

    temp = node[0];

    while (temp->next != node[0]) {
	temp = temp->next;

	// This if checks the actual number and prints the arrow
	if (temp->number == actual_node->number)
	    strcpy (arrow, " <--");
	else
	    strcpy (arrow, "    ");

	textprintf (screen, font, 0, y, 15, "%d%s\n", temp->number, arrow);
	y += 8;
    }

    textprintf (screen, font, 0, SCREEN_H - 20, 15, "Actual node %d\n", actual_node->number);
    textprintf (screen, font, 0, SCREEN_H - 10, 15, "Press F to cycle forward, B to cycle backwards, and ESC to exit\n");
}
