#include <stdlib.h>
#include <allegro.h>
#include "0532uc.h"
#include "0532u.h"

CIRCLE_T *circle_init(int new_x, int new_y, int new_radius,
		    int new_col, int new_xs, int new_ys, CIRCLE_T * prev)
{
    CIRCLE_T *temp;

    temp = malloc(sizeof(CIRCLE_T));
    if (temp == NULL)
	return NULL;

    temp->prev = prev;
    temp->next = NULL;
    temp->x = new_x;
    temp->y = new_y;
    temp->r = new_radius;
    temp->col = new_col;
    temp->xs = new_xs;
    temp->ys = new_ys;
    temp->dx = temp->dy = 0;

    if (prev) prev->next = temp;

    return temp;
}

void circle_draw(BITMAP * bmp)
{
    CIRCLE_T *circle;

    circle = circles[0];

    while (circle->next != NULL) {
	circle = circle->next;

	circlefill(bmp, circle->x, circle->y, circle->r, circle->col);

	circle->dx = circle->x;
	circle->dy = circle->y;
    }
}

void circle_update(void)
{
    CIRCLE_T *circle;

    circle = circles[0];

    while (circle->next != NULL) {
	circle = circle->next;

	// First we update the position of the circle...
	circle->x += circle->xs;
	circle->y += circle->ys;

	// Now we see if it reached the maximum frame border

	if (circle->x > SCREEN_W - 5)
	    circle->xs *= -1;

	if (circle->y > SCREEN_H - 5)
	    circle->ys *= -1;

	if (circle->x < 5)
	    circle->xs *= -1;

	if (circle->y < 5)
	    circle->ys *= -1;
    }
}

void circle_erase(BITMAP * bmp)
{
    CIRCLE_T *temp;

    temp = circles[0];

    while (temp->next != NULL) {
	temp = temp->next;
	circlefill(bmp, temp->dx, temp->dy, temp->r, 0);
    }
}

void circle_destroy(CIRCLE_T * circle)
{
    if (circle->prev) circle->prev->next = circle->next;
    if (circle->next) circle->next->prev = circle->prev;

    circle->next = circle->prev = NULL;
    circlefill(dblbuffer, circle->dx, circle->dy, circle->r, 0);

    free(circle);
}
