#include <stdio.h>
#include <string.h>
#include <allegro.h>

char key_buffer[80];		// Here we store the pressed keys...

/* This is a simple function:
 * It scans all the scancodes and prints a text according to the pressed key.
 * Quite a lot to write, but not so difficult to figure out ;-)
 */

void scan_keycodes(void)
{
    int c;
    char temp[1024];

    sprintf(key_buffer, " ");
    key_buffer[0] = '\0';

    for (c = 1; c < 128; c++) {
	if (key[c]) {
	    switch (c) {
	    case KEY_ESC:
		strcat(key_buffer, "ESC, bye bye...");
		return;
		break;
	    case KEY_BACKSPACE:
		strcat(key_buffer, "BACKSPACE ,");
		break;
	    case KEY_TAB:
		strcat(key_buffer, "TAB ,");
		break;
	    case KEY_ENTER:
		strcat(key_buffer, "ENTER ,");
		break;
	    case KEY_LCONTROL:
		strcat(key_buffer, "LEFT CONTROL ,");
		break;
	    case KEY_LSHIFT:
		strcat(key_buffer, "LEFT SHIFT ,");
		break;
	    case KEY_STOP:
		strcat(key_buffer, "STOP ,");
		break;
	    case KEY_RSHIFT:
		strcat(key_buffer, "RIGHT SHIFT ,");
		break;
	    case KEY_ALT:
		strcat(key_buffer, "ALT ,");
		break;
	    case KEY_SPACE:
		strcat(key_buffer, "SPACE ,");
		break;
	    case KEY_CAPSLOCK:
		strcat(key_buffer, "CAPSLOCK ,");
		break;
	    case KEY_F1:
	    case KEY_F2:
	    case KEY_F3:
	    case KEY_F4:
	    case KEY_F5:
	    case KEY_F6:
	    case KEY_F7:
	    case KEY_F8:
	    case KEY_F9:
	    case KEY_F10:
		sprintf(temp, "F%d ,", c - KEY_F1 + 1);
		strcat(key_buffer, temp);
		break;
	    case KEY_NUMLOCK:
		strcat(key_buffer, "NUMLOCK ,");
		break;
	    case KEY_SCRLOCK:
		strcat(key_buffer, "SCRLOCK ,");
		break;
	    case KEY_HOME:
		strcat(key_buffer, "HOME ,");
		break;
	    case KEY_UP:
		strcat(key_buffer, "UP ,");
		break;
	    case KEY_PGUP:
		strcat(key_buffer, "PGUP ,");
		break;
	    case KEY_MINUS_PAD:
		strcat(key_buffer, "MINUS PAD ,");
		break;
	    case KEY_LEFT:
		strcat(key_buffer, "LEFT ,");
		break;
	    case KEY_5_PAD:
		strcat(key_buffer, "5 PAD ,");
		break;
	    case KEY_RIGHT:
		strcat(key_buffer, "RIGHT ,");
		break;
	    case KEY_PLUS_PAD:
		strcat(key_buffer, "PLUS PAD ,");
		break;
	    case KEY_END:
		strcat(key_buffer, "END ,");
		break;
	    case KEY_DOWN:
		strcat(key_buffer, "DOWN ,");
		break;
	    case KEY_PGDN:
		strcat(key_buffer, "PGDN ,");
		break;
	    case KEY_INSERT:
		strcat(key_buffer, "INSERT ,");
		break;
	    case KEY_DEL:
		strcat(key_buffer, "DEL ,");
		break;
	    case KEY_PRTSCR:
		strcat(key_buffer, "PRTSCR ,");
		break;
	    case KEY_F11:
		strcat(key_buffer, "F11 ,");
		break;
	    case KEY_F12:
		strcat(key_buffer, "F12 ,");
		break;
	    case KEY_LWIN:
		strcat(key_buffer, "LWIN ,");
		break;
	    case KEY_RWIN:
		strcat(key_buffer, "RWIN ,");
		break;
	    case KEY_MENU:
		strcat(key_buffer, "MENU ,");
		break;
	    case KEY_RCONTROL:
		strcat(key_buffer, "RCONTROL ,");
		break;
	    case KEY_ALTGR:
		strcat(key_buffer, "ALTGR ,");
		break;
	    case KEY_PAUSE:
		strcat(key_buffer, "PAUSE ,");
		break;
	    default:
		sprintf(temp, "%c ,", scancode_to_ascii(c));
		strcat(key_buffer, temp);
		break;
	    }
	}
    }

    if (strlen(key_buffer) == 0)
	sprintf(key_buffer, "none keys!");
    else
	key_buffer[strlen(key_buffer) - 1] = 46;
}

int main(void)
{
    int loop = 0, old_length = 0, c;
    char text[1024];

    allegro_init();
    install_keyboard();

    printf("Keyclash test. Press several keys at the same time. Esc to exit\n\n");

    while (loop < 2) {
	scan_keycodes();
	sprintf(text, "You are pressing %s", key_buffer);
	printf("\r%s", text);

	// Now we erase the previous text...
	for (c = old_length - strlen(text); c > 0; c--)
	    printf(" ");
	old_length = strlen(text);

	if (key[KEY_ESC])
	    loop++;
    }

    return 0;
}
END_OF_MAIN()

