#include <stdio.h>
#include <allegro.h>
#include "0632.h"
#include "0632c.h"

int end_game;			/* flag we'll set to end the game */
int pressed_fire_button;	// This will help with the color feature

BITMAP *dblbuffer;

CIRCLE_T *moving_circle;

int main(void)
{
    allegro_init();		/* initialise the Allegro library */
    init();			/* initialise the game */

    end_game = 0;		/* reset flag */

    do {			/* loop */
	input();		/* get input */
	process();		/* process it */
	output();		/* give output */
    } while (end_game == 0);	/* until the flag is set */

    shutdown();			/* shut down anything that needs it */
    allegro_exit();		/* just for luck */
    return 0;			/* tell the OS that all went well */
}
END_OF_MAIN()

void init(void)
{
    int i;

    install_keyboard();

    i = install_mouse();

    if (i == -1) {
	printf("Sorry, didn't detect any mouse\n");
	exit(1);
    }
    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	printf("%s\n", allegro_error);
	exit(2);
    }
    dblbuffer = create_bitmap(SCREEN_W, SCREEN_H);
    if (dblbuffer == NULL) {
	allegro_exit();
	printf("Sorry, not enough memory");
	exit(3);
    }
    clear(dblbuffer);

    moving_circle = circle_init(SCREEN_W / 2, SCREEN_H / 2, 50, 3, 0, 0);
    if (moving_circle == NULL) {
	allegro_exit();
	printf("Sorry, not enough memory");
	exit(4);
    }
    pressed_fire_button = 0;

    circle_draw(moving_circle, dblbuffer);
    show_double_buffer();
}

void input(void)
{
    int dx, dy;

    if (key[KEY_ESC])
	end_game++;

    get_mouse_mickeys(&dx, &dy);

    if ((mouse_b & 1) != pressed_fire_button) {
	pressed_fire_button = moving_circle->col;
	while (pressed_fire_button == moving_circle->col)
	    moving_circle->col = rand() % 14;

	pressed_fire_button = mouse_b & 1;
    }
    moving_circle->xs += dx;
    moving_circle->ys += dy;
}

void process(void)
{
    circle_update(moving_circle);
}

void output(void)
{
    circle_erase(moving_circle, dblbuffer);
    circle_draw(moving_circle, dblbuffer);

    show_double_buffer();
}

void shutdown(void)
{
    circle_destroy(moving_circle);
    destroy_bitmap(dblbuffer);
}

void show_double_buffer(void)
{
    vsync();
    blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}
