// Measuring the frame rate

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <allegro.h>
#include "0942.h"

int pixels_per_frame;
int end_example;

volatile int last_fps;
volatile int frame_counter;

BITMAP *dblbuffer;

void count_frames()
{
    last_fps = frame_counter;
    frame_counter = 0;
}

END_OF_FUNCTION(count_frames);

int main(void)
{
    init_example();

    while (end_example == 0) {

	if (keypressed())
	    end_example++;

	draw_screen();
	frame_counter++;
    }

    return 0;
}
END_OF_MAIN();

void draw_screen()
{
    int f;

    for (f = 0; f < pixels_per_frame; f++)
	dblbuffer->line[rand() % SCREEN_H][rand() % SCREEN_W] = rand() % 256;

    textprintf(dblbuffer, font, 0, 0, 15, "Frames per second: %d", last_fps);

    blit(dblbuffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}

void init_example()
{
    srand(time(NULL));

    printf("How many pixels to draw per frame ? (I recommend 20000): ");
    scanf("%d", &pixels_per_frame);

    if (pixels_per_frame < 1)
	pixels_per_frame = 20000;

    allegro_init();
    install_keyboard();
    install_timer();

    LOCK_VARIABLE(last_fps);
    LOCK_VARIABLE(frame_counter);
    LOCK_FUNCTION(count_frames);
    install_int_ex(count_frames, BPS_TO_TIMER(1));

    end_example = last_fps = frame_counter = 0;

    dblbuffer = create_bitmap(320, 200);
    if (dblbuffer == NULL) {
	allegro_exit();
	printf("Sorry, not enough memory");
	exit(1);
    }
    clear(dblbuffer);
    if (set_gfx_mode(GFX_AUTODETECT, 320, 200, 0, 0) < 0) {
	printf("%s\n", allegro_error);
	exit(2);
    }
}
