#include <allegro.h>
#include "1031.h"
#include "datafile.h"

int load_our_datafile(void)
{
    int f;

    /* Look, since this example can be run from the main src/ dir or from some
     * src/10/3.x dir, to avoid having duplicated datafiles we will try
     * loading the data from the current dir, if not found, 2 dirs up.
     * But this isn't the point of the example. The important thing is that
     * you see 'how' you have to load the data in memory.
     */

    if (file_exists("datafile.dat", 0, NULL) != 0)
	data = load_datafile("datafile.dat");
    else
	data = load_datafile("../../datafile.dat");

    if (data == NULL)
	return 1;		// Error.

    // Ok, so the datafile has been loaded, now assign the wrappers...

    background = data[BACKGROUND].dat;
    custom_font = data[CUSTOM_FONT].dat;
    music = data[MUSIC].dat;
    pal_example = data[PAL_EXAMPLE].dat;
    walk = data[WALK].dat;

    for (f = 0; f < 10; f++)
	sprite[f] = data[SPR01 + f].dat;

    return 0;			// Data loaded.

}

void unload_our_datafile(void)
{
    unload_datafile(data);
}
